%
% Comentarios generales sobre el programa
%
%
% Este programa esta pensado para representar graficamente aspectos
% relacionados con los movimientos armonicos y oscilatorios, y de esta
% manera ayudar a comprender el pepel que juega cada uno de los parametros
% (trigonometricos o fisicos) en un problema que involucre este tipo de
% funciones o movimientos.
%
%
% El programa permite al usuario ajustar los parametros mediante una
% interfaz grafica y luego graficar la situacion correspondiente.
%
% Para correr el programa hace falta el archivo .fig que contiene los
% elementos de la interfaz grafica y el archivo con el mismo nombre .m que
% contiene los elementos de programacion de deicha interfaz.
%
% Entre los elementos de programacion, la mayoria de las funciones son
% funciones que el propio matlab genera automaticamente al agregar
% elementos a la interfaz, pero hay unas pocas funciones que donde esta
% concentrado el codigo programado manualmente que se encarga de que el
% programa haga lo deseado.
%
%
% Diseno general de la programacion
% 
% 
% La manera de activar la programacion que hay detras de la interfaz es
% modificando (haciendo click) sobre alguno de sus elementos. El diseno del
% programa es tal que cada vez que el usuario modifica un parametro (con un
% control desplazante), se activa una funcion que, por un lado recalcula
% todos los valores de los parametros indirectos y por otro lado actualiza
% en la pantalla todos los textos donde se muestran dichos numeros.
% 
% Este codigo esta escrito en la funcion Actualizar_Bttn_Callback, que es
% el bloque que se ejecuta al apretar un boton invisible llamado
% actualizar. Cada vez que el usuario toca alguna barra para modificar un
% valor, se simula que se apreto ese boton y se actualiza todos los
% parametros involucrados el programa.
%
% Otra parte diferente del programa es la que se ejecuta cuando el usuario
% aprieta el boton graficar (funcion Graph_Bttn_Callback). Esta funcion
% toma los valores ya almacenados en unos cuadros de texto invisibles al
% usuario (donde la funcion actualizar guardo todos los parametros que
% podrian ser relvantes) y con el conjunto necesario de esos parametros
% calcula y grafica (segun corresponda) las funciones posicion, velocidad y
% energias en funcion del tiempo.
%



%
%
% Notas internas:
%
% Falta considerar el caso critico. Mirando las cuentas el caso critico
% deberia deverger y probablemnete dar un error al dividir por cero, pero
% como muchos parametros son indirectos e incluyen cuentas con raices
% cuadradas que matlab en elgun punto redondea, y para colmo los valores 
% que el usuario puede elegir son discretos, es posible que este caso nunca
% se de en los hechos. En las pruebas hechas hasta ahora nunca se dio.
%
% Tambien habria que revisar las cuentas. Marque con un "%Cuenta" cada linea
% que encontre donde se hacia alguna cuenta. En general intente usar
% nombres de variables que coincidan con los nombres usuales que se les da
% a dichos valores, lo que no esta es marcado el subindice cero por ejemplo
% en las variables X (inicial) y V (inicial). Las cuentas que hice estan
% basadas en las cuentas que figuran en la guis de tps de oscilatorio y
% usan la representacion donde la posicion esta calculada con la funcion
% seno.
%
%

%
% Pendientes!
%
% - Creo que hay un problema de eficiencia porque cuando grafica animado va
% superponiendo todas las capas de muchos graficos iguales
% 
% Una opcion es sacar el hold on y que en el primer grafico nuevo de cada
% ciclo borre lo anterior, pero en ese caso se va la escala manual y pasa a
% escala automatica, por lo que hay que volver a setear la escala en cada
% ciclo (Es lo que esta hecho en la animacion porque ahi si no sirve que
% acumule un grafico sobre otro). Habria que reviar que es lo mas
% eficiente.
%



%
% Revision 27/08/2014
%

% Corregido que cuando hay seleccionado un modo (matematico o fisico) no se
% pueda cambiar los parametros del otro modo (para evitar confusion en los
% usuarios, y que solo puedan modificar lo que se va a graficar. Tambien
% deshabilita los dos modos al inicio para que se active el correcto cuando
% el usuario elige por primera vez

%
% Error detectado. Si solo grafica enegia total no selecciona un plot nuevo
% y superpone el grafico de energia y el de energia total. Corregido
%

%
% Error detectado y corregido, al marcar o desmarcar la opcion de graficar
% posicion no se activavav el codigo de actualizacion correspondiente
%

%
% Mejora: Hasta ahora numeraba las curvas debajo del primer minimo. Eso
% esta bien si las condiciones iniciales son positivas, pero sino no,
% porque en el caso amortiguado se superponen las numeraciones. Se modifica
% para que etiquete las curvas en el primer maximo/minimo segun el signo de
% la condicion inicial. 
%

%
% Nombre de version : 1.1
%


%
% Error pendiente: Al parecer el calculo de la velocidad en el caso
% sobreamortiguado esta mal, porque con condiciones iniciales de velocidad
% nula da velocidad inicial no nula. (aprox linea 358)
%








function varargout = Oscilatorio(varargin)
% OSCILATORIO MATLAB code for Oscilatorio.fig
%      OSCILATORIO, by itself, creates a new OSCILATORIO or raises the existing
%      singleton*.
%
%      H = OSCILATORIO returns the handle to a new OSCILATORIO or the handle to
%      the existing singleton*.
%
%      OSCILATORIO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OSCILATORIO.M with the given input arguments.
%
%      OSCILATORIO('Property','Value',...) creates a new OSCILATORIO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Oscilatorio_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Oscilatorio_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Oscilatorio

% Last Modified by GUIDE v2.5 27-Aug-2014 16:48:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Oscilatorio_OpeningFcn, ...
                   'gui_OutputFcn',  @Oscilatorio_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Oscilatorio is made visible.
function Oscilatorio_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Oscilatorio (see VARARGIN)

% Choose default command line output for Oscilatorio
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes Oscilatorio wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%
% Codigo que se ejecuta el iniciarse el programa 
%

%Inhabilita que se modifiquen los parametros fisico y habilita que se
%modifiquen los matematico (opcion con que se enciende el programa)
set(findobj('Tag','Frec_Control'),'Enable','on')
set(findobj('Tag','Ampl_Control'),'Enable','on')
set(findobj('Tag','Fase_Control'),'Enable','on')
set(findobj('Tag','Const_Control'),'Enable','off')
set(findobj('Tag','Masa_Control'),'Enable','off')
set(findobj('Tag','Pos_Control'),'Enable','off')
set(findobj('Tag','Vel_Control'),'Enable','off')
set(findobj('Tag','Amort_Control'),'Enable','off')



% --- Outputs from this function are returned to the command line.
function varargout = Oscilatorio_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function Frec_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Frec_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function Frec_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Frec_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Ampl_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Ampl_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function Ampl_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ampl_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Fase_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Fase_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)




% --- Executes during object creation, after setting all properties.
function Fase_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Fase_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Graph_Bttn.
function Graph_Bttn_Callback(hObject, eventdata, handles)
% hObject    handle to Graph_Bttn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



%Carga los datos
A= str2double(get(handles.Ampl_Aux, 'String'));
W= str2double(get(handles.Frec_Aux, 'String'));
Phase= str2double(get(handles.Phase_Aux, 'String'));
WPrima= str2double(get(handles.WPrima_Aux, 'String'));
Lambda= str2double(get(handles.Lambda_Aux, 'String'));
M= str2double(get(handles.Masa_Aux, 'String'));
Lambda1= str2double(get(handles.Lambda1_Text, 'String'));
Lambda2= str2double(get(handles.Lambda2_Text, 'String'));
A1= str2double(get(handles.A1_Text, 'String'));
A2= str2double(get(handles.A2_Text, 'String'));
K = str2double(get(handles.Kela_Aux, 'String'));

%Cuentas para ajustar escala
% Notar que si es sobreamortiguado tiene sentido seguir usando la escala
% del Wo como referencia.
Log=log10(1/W);
LogEnt=fix(Log);
Xf= 10^(LogEnt+1);  

%Define la absisa
Xpaso= Xf/1000;
X=0:Xpaso:Xf;

%Inicializa las variables resultados
Y=zeros(1,length(X));
YN=zeros(1,length(X));
Vel=zeros(1,length(X));
ECin=zeros(1,length(X));
EPot=zeros(1,length(X));
ETot=zeros(1,length(X));
EnvSup=zeros(1,length(X));
EnvInf=zeros(1,length(X));

% Calcula Posicion
if get(handles.Parametros_Chk,'Value')==1 || get(handles.SobreAmortiguado_Chk,'Value')==0 %Caso oscilatorio
    for i=1:length(X)
        Y(i)=A*sin(WPrima*X(i)+Phase)*exp(-Lambda*X(i)); %Cuenta
        EnvSup(i)=A*exp(-Lambda*X(i)); %Cuenta
        EnvInf(i)=-A*exp(-Lambda*X(i)); %Cuenta
    end
else %Caso sobreamortiguado
    for i=1:length(X)
        Y(i)=A1*exp(Lambda1*X(i)) + A2*exp(Lambda2*X(i)); %Cuenta
    end
end
   

%Calcula la velocidad
if get(handles.Parametros_Chk,'Value')==1 || get(handles.SobreAmortiguado_Chk,'Value')==0 
    for i=1:length(X)
        Vel(i)=-A*exp(-Lambda*X(i))*(Lambda*sin(WPrima*X(i)+Phase)-WPrima*cos(WPrima*X(i)+Phase)); %Cuenta
    end
else %Caso sobreamortiguado. 
    for i=1:length(X)
        Vel(i)=A1*Lambda1*exp(Lambda1*X(i)) + A2*Lambda2*exp(Lambda2*X(i)); %Cuenta
    end
end

%Calcula posicion para no amortiguado (ver q le llegue bien el parametro)
for i=1:length(X)
    YN(i)=A*sin(W*X(i)+Phase); %Cuenta
end

%Calcula la ECin (Si esta en el caso trigonometrico igual despues no lo grafica)
ECin= 1/2*M*Vel.*Vel; %Cuenta

%Calcula la EPot (Si esta en el caso trigonometrico igual despues no lo grafica)
EPot= 1/2*K*Y.*Y; %Cuenta

ETot=ECin+EPot; %Cuenta



%
% Inicia el proceso de graficar, o animado o estatico
%


if get(handles.Animar_Chk,'Value')==0
    %Grafica las cosas relacionadas a posicion y velocidad segun corresponda


    Numero=str2num(get(handles.Retener_Text,'string'));
    if get(handles.Retener_Chk,'value') == 0 %Solo crea una nueva figura si esta marcado que no acumule
        figure;
    else
        h=figure(1);
        if Numero==0 % Si el numero esta en cero borra la figura 1 y crea una nueva para limpiarla
            delete(h);
            h=figure(1);
        end
        set(handles.Retener_Text,'string',num2str(Numero+1)) %Aumenta el contador
    end
    title('Grafico de posicion y velocidad en funcion del tiempo');
    xlabel('Tiempo (s)');
    ylabel('Posicion (m), Velocidad (m/s)');

    hold on
    %Grafica posicion
    if get(handles.Pos_Chk,'Value')==1
        plot (X,Y,'blue')
        
        % Si hay varias figuras superpuestas las etiqueta
        if get(handles.Retener_Chk,'value') == 1
            if Y(1)>0
                [Ytext,Xtext]=min(Y);
            else
                [Ytext,Xtext]=max(Y);
            end
            text(X(Xtext),Ytext,strcat('(',num2str(Numero),')'))
        end
        
    end
    
    %Grafica Velocidad
    if get(handles.Vel_Chk,'Value')==1
        plot (X,Vel,'red')
        
        % Si hay varias figuras superpuestas las etiqueta
        if get(handles.Retener_Chk,'value') == 1
            if Vel(1)>0
                [Ytext,Xtext]=min(Vel);
            else
                [Ytext,Xtext]=max(Vel);
            end
            text(X(Xtext),Ytext,strcat('(',num2str(Numero),')'))
        end
        
    end
    
    if get(handles.NoAmort_Chk,'Value')==1
        plot (X,YN,'black')
    end
    if get(handles.Env_Chk,'Value')==1
        plot (X,EnvSup,'green')
        plot (X,EnvInf,'green')
    end
    hold off


    %Grafica las cosas asociadas a energia segun corresponda
    if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Etot_Chk,'Value')==1
        figure;
        title('Grafico de Energias en funcion del tiempo');
        xlabel('Tiempo (s)');
        ylabel('Energia (J)');
    end

    hold on
    if get(handles.Cinet_Chk,'Value')==1
        plot (X,ECin,'red')
    end
    if get(handles.Pot_Chk,'Value')==1
        plot (X,EPot,'blue')
    end
    if get(handles.Etot_Chk,'Value')==1
        plot (X,ETot,'black')
    end
    hold off

else % Inicia graficos animados
    

    figure %Crea la figura vacia(en este caso es unica)
    %maximize; %Maximiza la ventana

    % Calcula el maximo y minimo del grafico de posicion/velocidad
    if get(handles.Vel_Chk,'Value')==1
        YminV=min(Vel);
        YmaxV=max(Vel);
    else
        YminV=0;
        YmaxV=0;
    end
    if get(handles.Pos_Chk,'Value')==1
        YminY=min(Y);
        YmaxY=max(Y);
    else
        YminY=0;
        YmaxY=0;
    end
    if get(handles.NoAmort_Chk,'Value')==1
        YminYN=min(YN);
        YmaxYN=max(YN);
    else
        YmaxYN=0;
        YminYN=0;
    end
    Vecmin=[YminV,YminY,YminYN];
    YminPos=min(Vecmin); % Calcula el minimo de los tres vectores
    Vecmax=[YmaxV,YmaxY,YmaxYN];
    YmaxPos=max(Vecmax); % Calcula el maximo de los tres vectores

    
    % Calcula el maximo y minimo del grafico de energias
    if get(handles.Cinet_Chk,'Value')==1
        YminCin=min(ECin);
        YmaxCin=max(ECin);
    else
        YminCin=0;
        YmaxCin=0;
    end
    if get(handles.Pot_Chk,'Value')==1
        YminEpot=min(EPot);
        YmaxEpot=max(EPot);
    else
        YminEpot=0;
        YmaxEpot=0;
    end
    if get(handles.NoAmort_Chk,'Value')==1
        YminEtot=min(ETot);
        YmaxEtot=max(ETot);
    else
        YmaxEtot=0;
        YminEtot=0;
    end
    Vecmin=[YminCin,YminEpot,YminEtot];
    YminE=min(Vecmin); % Calcula el minimo de los tres vectores
    Vecmax=[YmaxCin,YmaxEpot,YmaxEtot];
    YmaxE=max(Vecmax); % Calcula el maximo de los tres vectores

        
    if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
        %En este caso tiene que crear el subplot para energias y para
        %posiciones
        
        % Setea el grafico de posicion
        subplot(1,3,2)
        title('Grafico de posicion y velocidad en funcion del tiempo');
        xlabel('Tiempo (s)');
        ylabel('Posicion (m), Velocidad (m/s)');
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al principio
        
        
        % Setea el grafico de energias
        subplot(1,3,3)
        title('Grafico de Energias en funcion del tiempo');
        xlabel('Tiempo (s)');
        ylabel('Energia (J)');
        axis([0,X(length(X)),YminE,YmaxE]) % Setea los ejes una vez
        
        %Arma el grafico de la animacion
        
        subplot(1,3,1)
        title('Movimiento animado');
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al principio
    
    else % En este caso solo hay grafico de posiciones y lo setea
        subplot(1,2,2)
        title('Grafico de posicion y velocidad en funcion del tiempo');
        xlabel('Tiempo (s)');
        ylabel('Posicion (m), Velocidad (m/s)');
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al principio
    
        %Arma el grafico de la animacion
        subplot(1,2,1)
        title('Movimiento animado');
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al principio
    end

    %Ya tiene los graficos creados
    
    % Calcula el paso al q tiene que ir. 0 y 1 representan el paso mas
    % lento (que haga 100 pasos para todo el grafico) 100 representa hacer
    % todo el grafico de una
    
    Paso= str2double(get(handles.VelAni_Text, 'String'));
    Paso= 10 - Paso; % Invierte la escala
    Paso=Paso/5; % Reescala para que 10 pase a ser 2 (osea 100 despues) y 0 siga siendo cero
    Paso=fix(10^(Paso+1)); % Hace que la escala sea exponencial, un 0 original representa y a 1/100 un 10 ir al maximo
    Paso=fix(length(X)/Paso);

    
    % Calcula aca afuera un parametro para tener idea del tamao maximo de
    % la aceleracion
    NormaAcel=max(diff(Vel))/(X(2)-X(1));

    for i=1:Paso:length(X)
        
        drawnow %Esto da tiempo a que se actualice los graficos
        
        % Hace el grafico animado
        if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
            subplot(1,3,1) % Selecciona el segundo de tres subplots si tiene que graficar energias
        else
            subplot(1,2,1) % Selecciona el segundo de dos subplots si no tiene que graficar energias
        end
        
        % Hay que revisar q cargue bien los datos. Esto esta aca porque
        % apagar el hold on hace que se reescale
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al princi

        
        %Crea datos que sirvan para representar en el grafico animado las
        %cosas
        if i<(length(X)-1) %Para que no quiera buscar el elemento siguiente al ultimo. El ultimo elemento se ve repetido como el anteultimo.
            XAni=[X(fix(length(X)/2)),X(fix(length(X)/2)+1)];
            VecPos=[0,Y(i)];
            VecVel=[Y(i),Y(i)+Vel(i)];
            %Arma una flecha aceleracion
            XAniA=[X(fix(length(X)*3/4)),X(fix(length(X)*3/4)+1)];
            VecAcel=[0,(Vel(i+1)-Vel(i))/(X(i+1)-X(i))];
            VecAcel=(VecAcel/NormaAcel)*YmaxPos/5;
        end
        
        hold off %Apaga el hold para que la primer flecha borre todo lo anterior
        
        if Y(i)>0
            plot(XAni,VecPos,'--bs','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','b',...
                'MarkerSize',30)
        else
            plot(XAni,VecPos,'--bs','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','b',...
                'MarkerSize',30)
        end
            
        hold on

                % Hay que revisar q cargue bien los datos. Esto esta aca porque
        % apagar el hold on hace que se reescale
        axis([0,X(length(X)),YminPos,YmaxPos]) % Setea los ejes una vez al princi


        if Vel(i)>0
            plot(XAni,VecVel,'--r^','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','r',...
                'MarkerSize',10)
        else
            plot(XAni,VecVel,'--rv','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','r',...
                'MarkerSize',10)
        end
        
        
        
        if VecAcel(2)>0
            plot(XAniA,VecAcel,'--k^','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','k',...
                'MarkerSize',10)
        else
            plot(XAniA,VecAcel,'--kv','LineWidth',2,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor','k',...
                'MarkerSize',10)
        end
        
        % Pone etiqueta en el grafico
        text (X(fix(length(X)*4/5)),0,'a(t)')

        hold off
        
        %Grafica las cosas relacionadas a posicion y velocidad segun corresponda
        
        if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
            subplot(1,3,2) % Selecciona el segundo de tres subplots si tiene que graficar energias
        else
            subplot(1,2,2) % Selecciona el segundo de dos subplots si no tiene que graficar energias
        end
        
        hold on
        if get(handles.Pos_Chk,'Value')==1
            plot (X(1:i),Y(1:i),'blue')
        end
        if get(handles.Vel_Chk,'Value')==1
            plot (X(1:i),Vel(1:i),'red')
        end
        if get(handles.NoAmort_Chk,'Value')==1
            plot (X(1:i),YN(1:i),'black')
        end
        if get(handles.Env_Chk,'Value')==1
            plot (X(1:i),EnvSup(1:i),'green')
            plot (X(1:i),EnvInf(1:i),'green')
        end

        hold off


        %Grafica las cosas asociadas a energia segun corresponda
        if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
            subplot(1,3,3) % Selecciona el tercero de tres graficos si tiene que graficar energia
        end
        
        hold on
        if get(handles.Cinet_Chk,'Value')==1
            plot (X(1:i),ECin(1:i),'red')
        end
        if get(handles.Pot_Chk,'Value')==1
            plot (X(1:i),EPot(1:i),'blue')
        end
        if get(handles.Etot_Chk,'Value')==1
            plot (X(1:i),ETot(1:i),'black')
        end
        hold off
    end

        %Grafica completo cuando termino, para que no corte mal
        if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
            subplot(1,3,2) % Selecciona el segundo de tres subplots si tiene que graficar energias
        else
            subplot(1,2,2) % Selecciona el segundo de dos subplots si no tiene que graficar energias
        end
        
        hold on
        if get(handles.Pos_Chk,'Value')==1
            plot (X,Y,'blue')
        end
        if get(handles.Vel_Chk,'Value')==1
            plot (X,Vel,'red')
        end
        if get(handles.NoAmort_Chk,'Value')==1
            plot (X,YN,'black')
        end
        if get(handles.Env_Chk,'Value')==1
            plot (X,EnvSup,'green')
            plot (X,EnvInf,'green')
        end

        hold off


        %Grafica las cosas asociadas a energia segun corresponda
        if get(handles.Cinet_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1 || get(handles.Pot_Chk,'Value')==1
            subplot(1,3,3) % Selecciona el tercero de tres graficos si tiene que graficar energia
        end

        hold on
        if get(handles.Cinet_Chk,'Value')==1
            plot (X,ECin,'red')
        end
        if get(handles.Pot_Chk,'Value')==1
            plot (X,EPot,'blue')
        end
        if get(handles.Etot_Chk,'Value')==1
            plot (X,ETot,'black')
        end
        hold off

    
end




% --- Executes on slider movement.
function Const_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Const_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function Const_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Const_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Actualizar_Bttn.
function Actualizar_Bttn_Callback(hObject, eventdata, handles)
% hObject    handle to Actualizar_Bttn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Anota valor en parametro decaimiento
set(handles.Amort_Text, 'String', num2str(get(handles.Amort_Control, 'Value')))


% Anota los valores numericos de los indicadores de arriba
set(handles.Frec_Text, 'String', num2str(get(handles.Frec_Control, 'Value')))
set(handles.Ampl_Text, 'String', num2str(get(handles.Ampl_Control, 'Value')))

set(handles.Fase_Text, 'String', num2str(get(handles.Fase_Control, 'Value')))
Grados = get(handles.Fase_Control, 'Value') *360/(2*pi());
Texto= strcat (num2str(Grados), ' deg');
set(handles.Fase_Text2, 'String', Texto)


%Anota los valores numericos de los indicadores de abajo
set(handles.Const_Text, 'String', num2str(get(handles.Const_Control, 'Value')))
set(handles.Masa_Text, 'String', num2str(get(handles.Masa_Control, 'Value')))
set(handles.Pos_Text, 'String', num2str(get(handles.Pos_Control, 'Value')))
set(handles.Vel_Text, 'String', num2str(get(handles.Vel_Control, 'Value')))



%Se fija que set de datos usar y carga o calcula los valores de la ecuacion
if get(handles.Parametros_Chk, 'Value') == 1 %Si se usan los parametros
    
    %Carga los valores de los controles de arriba
    A=get(handles.Ampl_Control,'Value');
    W=get(handles.Frec_Control,'Value');
    Phase=get(handles.Fase_Control,'Value');
    
    % Los guarda en casilleros para que los pueda usar el proceso que
    % grafica (ver como mejorar... :s )
    set(handles.Ampl_Aux, 'String', num2str(A))
    set(handles.Frec_Aux, 'String', num2str(W))
    set(handles.Phase_Aux, 'String', num2str(Phase))
    
    set(findobj('Tag','Error_Text'), 'String', '') %Borra un posible mensaje de error
    set(handles.FormulaB_Text, 'String', '') %Borra la posible formula de abajo
    TextoFormula = strcat('X(t)= ',num2str(A),' * sin(',num2str(W),'t + ',num2str(Phase),')'); %Genera la formula
    set(handles.FormulaA_Text,'String',TextoFormula)

else %Ignora el amortiguamiento
    
    set(handles.Error_Text, 'String', '') %Borra un posible mensaje de error
    set(handles.FormulaA_Text, 'String', '') %Borra la posible formula de arriba

    
    M=get(handles.Masa_Control, 'Value');
    K=get(handles.Const_Control,'Value');
    X=get(handles.Pos_Control,'Value');
    V=get(handles.Vel_Control,'Value');
    
    if M==0
        set(handles.Error_Text, 'String', 'Para que la frecuencia tenga sentido debe establecer alguna masa')
        set(handles.Error_Chk, 'Value', 1)
        W=0;
    else
        W=sqrt(K/M); %Cuenta
        set(handles.Error_Chk, 'Value', 0)
    end
    
    if V==0
        Phase=pi()/2; %Cuenta
    else
        Phase= atan(X/V*W); %Cuenta
    end
    
    if sin(Phase) == 0
        A=V/W; %Cuenta
    else
        A=X/sin(Phase); %Cuenta
    end

    %Pone los valores calculados en los indicadores visibles
    set(handles.AmplB_Text, 'String', num2str(A))
    set(handles.FrecB_Text, 'String', num2str(W))
    set(handles.PhaseB_Text, 'String', num2str(Phase))
    Grados = Phase *360/(2*pi());
    Texto= strcat (num2str(Grados), ' deg');
    set(handles.PhaseB_Text2, 'String', Texto)
 
    %pone los valores calculados en los indicadores invisibles (para que lo
    %pueda tomar al graficar, mejorar :s)
    set(handles.Ampl_Aux, 'String', num2str(A))
    set(handles.Frec_Aux, 'String', num2str(W))
    set(handles.Phase_Aux, 'String', num2str(Phase))
    set(handles.Kela_Aux, 'String', num2str(K))

    
end


%Calcula WPrima y Lambda, evalua si es sobre amortiguado y anota el valor abajo

Gamma= str2double(get(handles.Amort_Text, 'String'));
M= str2double(get(handles.Masa_Text, 'String'));
X= str2double(get(handles.Pos_Text, 'String'));
V= str2double(get(handles.Vel_Text, 'String'));


if get(handles.Parametros_Chk, 'Value') == 1 %Caso de que este seleccionado el caso parametros trigonometricos
    WPrima=W;
    Lambda=0;
    set(handles.SobreAmortiguado_Chk, 'Value', 0) % Setea en falso el sobreamortiguado
else
    if M==0 %Se fija q pueda hacer las cuentas por causa de la masa. Si la masa es 0 ya aparece el mensaje de error
        WPrima=0;
        Lambda=0;
    else
        Lambda=Gamma/(2*M); %Cuenta
        if Lambda<=W %Caso sub amortiguado
            WPrima = sqrt(W * W - Lambda^2); %Cuenta
            set(handles.SobreAmortiguado_Chk, 'Value', 0) % Setea en falso el sobreamortiguado
            set(handles.Env_Chk,'Enable','on') % Permite graficar la envolvente 
        else % Caso sobreamortiguado
            WPrima = 0;
            set(handles.SobreAmortiguado_Chk, 'Value', 1) % Setea en verdadero el sobreamortiguado  
            set(handles.Env_Chk,'Value',0) % Desactiva la envolvente si estaba activada 
            set(handles.Env_Chk,'Enable','off') % No permite graficar la envolvente 
            
            
            Lambda1= - Lambda + sqrt(Lambda^2-W^2); %Cuenta
            Lambda2= - Lambda - sqrt(Lambda^2-W^2); %Cuenta
            % A1= (V-Lambda1*X)/(Lambda1-Lambda2); %Cuenta vieja
            A1= (V-Lambda2*X)/(Lambda2-Lambda1);
            A2= X-A1; %Cuenta
            
            % Guarda los valores calculados
            set(handles.Lambda1_Text, 'String', num2str(Lambda1))
            set(handles.Lambda2_Text, 'String', num2str(Lambda2))
            set(handles.A1_Text, 'String', num2str(A1))
            set(handles.A2_Text, 'String', num2str(A2))

        end
    end
    
end

% Guarda los valores calculados (esta fuera del fi porque varian segun cada
% caso)
set(handles.FrecPrima_Text, 'String', num2str(WPrima))
set(handles.WPrima_Aux, 'String', num2str(WPrima))
set(handles.Lambda_Aux, 'String', num2str(Lambda))
set(handles.Masa_Aux, 'String', num2str(M))

% Al final anota las formulas, porque neceita todos los parametros calculados
if get(handles.SobreAmortiguado_Chk,'Value')==0
    TextoFormula = strcat('X(t)= ',num2str(A),' * sin(',num2str(WPrima),'t + ',num2str(Phase),')*e^(-',num2str(Lambda),'t)'); %Genera la formula
else
    TextoFormula = strcat('X(t)= ',num2str(A1),'*e^(',num2str(Lambda1),'t) + ',num2str(A2),'*e^(',num2str(Lambda2),'t)'); %Genera la formula
end
if get(handles.Parametros_Chk,'Value')==0 %Solo graba la formula si esta seleccionado el modo fisico
    set(handles.FormulaB_Text,'String',TextoFormula) %Pone la formula correcta abajo
    set(handles.FormulaA_Text,'String','') % Borra la formula de arriba
end
   
%Actualiza el control de velocidad de animacion
set(handles.VelAni_Text, 'String', num2str(get(handles.VelAni_Control, 'Value')))



% --- Executes on slider movement.
function Masa_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Masa_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function Masa_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Masa_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Pos_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Pos_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Pos_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pos_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Vel_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Vel_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Vel_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Vel_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Error_Chk.
function Error_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Error_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Error_Chk


% --- Executes when selected object is changed in uipanel3.
function uipanel3_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel3 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA

% Se fija que esta seleccionado si parametros trigonometricos o condiciones
% inciales y ajusta en consecuencia
if  strcmp(get(eventdata.NewValue,'String'),get(findobj('Tag','Parametros_Botton'),'String')) %Pasa a un cuadro externo a el panel de botones el valor elegido porque no se sino como llamarlo deasde otro lado...
    
    %Marca que se eligieron los parametros trigonometricos
    set(findobj('Tag','Parametros_Chk'),'Value',1)

    %Inhabilita q grafique energias
    set(findobj('Tag','Pot_Chk'),'Enable','off')
    set(findobj('Tag','Cinet_Chk'),'Enable','off')
    set(findobj('Tag','Etot_Chk'),'Enable','off')
    set(findobj('Tag','NoAmort_Chk'),'Enable','off')
    set(findobj('Tag','Env_Chk'),'Enable','off')
    
    set(findobj('Tag','Pot_Chk'),'Value',0)
    set(findobj('Tag','Cinet_Chk'),'Value',0)
    set(findobj('Tag','Etot_Chk'),'Value',0)
    set(findobj('Tag','NoAmort_Chk'),'Value',0)
    set(findobj('Tag','Env_Chk'),'Value',0)
    
    %Inhabilita que se modifiquen los parametros fisico y habilita que se
    %modifiquen los matematico
    set(findobj('Tag','Frec_Control'),'Enable','on')
    set(findobj('Tag','Ampl_Control'),'Enable','on')
    set(findobj('Tag','Fase_Control'),'Enable','on')
    set(findobj('Tag','Const_Control'),'Enable','off')
    set(findobj('Tag','Masa_Control'),'Enable','off')
    set(findobj('Tag','Pos_Control'),'Enable','off')
    set(findobj('Tag','Vel_Control'),'Enable','off')
    set(findobj('Tag','Amort_Control'),'Enable','off')
    
else
    set(findobj('Tag','Parametros_Chk'),'Value',0)
    
    %Rehabilita q grafique energias
    set(findobj('Tag','Pot_Chk'),'Enable','on')
    set(findobj('Tag','Cinet_Chk'),'Enable','on')
    set(findobj('Tag','Etot_Chk'),'Enable','on')
    set(findobj('Tag','NoAmort_Chk'),'Enable','on')
    set(findobj('Tag','Env_Chk'),'Enable','on')

    
    %Inhabilita que se modifiquen los parametros matematico y habilita que se
    %modifiquen los fisicos
    set(findobj('Tag','Frec_Control'),'Enable','off')
    set(findobj('Tag','Ampl_Control'),'Enable','off')
    set(findobj('Tag','Fase_Control'),'Enable','off')
    set(findobj('Tag','Const_Control'),'Enable','on')
    set(findobj('Tag','Masa_Control'),'Enable','on')
    set(findobj('Tag','Pos_Control'),'Enable','on')
    set(findobj('Tag','Vel_Control'),'Enable','on')
    set(findobj('Tag','Amort_Control'),'Enable','on')
    
end

ActBotones_Bttn_Callback(hObject, eventdata, handles)
Actualizar_Bttn_Callback(hObject, eventdata, handles)



% --- Executes on button press in Parametros_Chk.
function Parametros_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Parametros_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Parametros_Chk


% --- Executes on slider movement.
function Amort_Control_Callback(hObject, eventdata, handles)
% hObject    handle to Amort_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function Amort_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Amort_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Pos_Chk.
function Pos_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Pos_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Pos_Chk

%Desabilita la opcion de animar si no se grafica o posicion o velocidad

ActBotones_Bttn_Callback(hObject, eventdata, handles)

    

% --- Executes on button press in Vel_Chk.
function Vel_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Vel_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Vel_Chk

ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in Cinet_Chk.
function Cinet_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Cinet_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Cinet_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in Pot_Chk.
function Pot_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Pot_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Pot_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in Etot_Chk.
function Etot_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Etot_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Etot_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in SobreAmortiguado_Chk.
function SobreAmortiguado_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to SobreAmortiguado_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SobreAmortiguado_Chk


% --- Executes on button press in NoAmort_Chk.
function NoAmort_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to NoAmort_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of NoAmort_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in Animar_Chk.
function Animar_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Animar_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Animar_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on slider movement.
function VelAni_Control_Callback(hObject, eventdata, handles)
% hObject    handle to VelAni_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
Actualizar_Bttn_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function VelAni_Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to VelAni_Control (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in Env_Chk.
function Env_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Env_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Env_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in Retener_Chk.
function Retener_Chk_Callback(hObject, eventdata, handles)
% hObject    handle to Retener_Chk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Retener_Chk
ActBotones_Bttn_Callback(hObject, eventdata, handles)


% --- Executes on button press in ActBotones_Bttn.
function ActBotones_Bttn_Callback(hObject, eventdata, handles)
% hObject    handle to ActBotones_Bttn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if get(handles.Cinet_Chk,'value')==1 || get(handles.Pot_Chk,'value')==1 || get(handles.Etot_Chk,'value')==1 || get(handles.Animar_Chk,'value')==1
    % Si hay alguna opcion de graficar energias o de animar deshabilita la opcion de
    % acumular los graficos
    set(handles.Retener_Chk,'enable','off')
    set(handles.Retener_Chk,'value',0)
else
    set(handles.Retener_Chk,'enable','on')
end

%Resetea el contador de graficos acumulados si se desmarca el boton de
%acumular
if get(handles.Retener_Chk,'value')==0
    set(handles.Retener_Text,'string','0')
end


%Deshabilita la opcion de animar si no se grafica o posicion o velocidad
if get(handles.Vel_Chk,'value')==0 && get(handles.Pos_Chk,'value')==0
    set (handles.Animar_Chk,'Enable','off')
    set (handles.Animar_Chk,'Value',0)
else
    set (handles.Animar_Chk,'Enable','on')
end
